package org.dromara.biz.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.StatDeptBo;
import org.dromara.biz.domain.vo.StatDeptVo;
import org.dromara.biz.domain.StatDept;
import org.dromara.biz.mapper.StatDeptMapper;
import org.dromara.biz.service.IStatDeptService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 单位每日数据统计Service业务层处理
 *
 * @author YIN
 * @date 2025-05-21
 */
@RequiredArgsConstructor
@Service
public class StatDeptServiceImpl implements IStatDeptService {

    private final StatDeptMapper baseMapper;

    /**
     * 查询单位每日数据统计
     *
     * @param id 主键
     * @return 单位每日数据统计
     */
    @Override
    public StatDeptVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询单位每日数据统计列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 单位每日数据统计分页列表
     */
    @Override
    public TableDataInfo<StatDeptVo> queryPageList(StatDeptBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<StatDept> lqw = buildQueryWrapper(bo);
        Page<StatDeptVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }
    /**
     * 分页查询单位每日数据统计列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 单位每日数据统计分页列表
     */
    @Override
    public TableDataInfo<StatDeptVo> queryPageStat(StatDeptBo bo, PageQuery pageQuery) {

        LambdaQueryWrapper<StatDept> lqw = Wrappers.lambdaQuery();
        Map<String, Object> params = bo.getParams();
        lqw.eq(bo.getDeptId() != null, StatDept::getDeptId, bo.getDeptId());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), StatDept::getDeptName, bo.getDeptName());
        lqw.between(params.get("beginTjrq") != null && params.get("endTjrq") != null,
                StatDept::getTjrq ,params.get("beginTjrq"), params.get("endTjrq"));
        lqw.groupBy(StatDept::getDeptId, StatDept::getDeptName);
        Page<StatDeptVo> result = baseMapper.queryPageStat(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的单位每日数据统计列表
     *
     * @param bo 查询条件
     * @return 单位每日数据统计列表
     */
    @Override
    public List<StatDeptVo> queryList(StatDeptBo bo) {
        LambdaQueryWrapper<StatDept> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<StatDept> buildQueryWrapper(StatDeptBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<StatDept> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(StatDept::getId);
        lqw.eq(bo.getDeptId() != null, StatDept::getDeptId, bo.getDeptId());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), StatDept::getDeptName, bo.getDeptName());
        lqw.between(params.get("beginTjrq") != null && params.get("endTjrq") != null,
                StatDept::getTjrq ,params.get("beginTjrq"), params.get("endTjrq"));

        return lqw;
    }

    /**
     * 新增单位每日数据统计
     *
     * @param bo 单位每日数据统计
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(StatDeptBo bo) {
        StatDept add = MapstructUtils.convert(bo, StatDept.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改单位每日数据统计
     *
     * @param bo 单位每日数据统计
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(StatDeptBo bo) {
        StatDept update = MapstructUtils.convert(bo, StatDept.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(StatDept entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除单位每日数据统计信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
